(function(global2, factory) {
  typeof exports === "object" && typeof module !== "undefined" ? factory(exports, require("@vue/runtime-core")) : typeof define === "function" && define.amd ? define(["exports", "@vue/runtime-core"], factory) : (global2 = typeof globalThis !== "undefined" ? globalThis : global2 || self, factory(global2["vue-form-handler"] = {}, global2.VueRuntimeCore));
})(this, function(exports2, runtimeCore) {
  "use strict";
  const DEFAULT_FIELD_VALUE = null;
  const BaseInputProps = {
    name: { type: String, required: true },
    isDirty: { type: Boolean, default: () => false },
    isTouched: { type: Boolean, default: () => false },
    disabled: { type: Boolean, default: () => false },
    error: { type: String, default: () => "" },
    onBlur: { type: Function, required: true },
    onClear: { type: Function, default: () => null },
    modelValue: {
      type: [String, Object, Array, Number, Boolean, null],
      required: true
    },
    "onUpdate:modelValue": { type: Function, required: true }
  };
  const BaseInputEmits = [
    "update:modelValue",
    "blur",
    "clear"
  ];
  const defaultInjectionKey = Symbol("formHandler");
  var freeGlobal = typeof global == "object" && global && global.Object === Object && global;
  const freeGlobal$1 = freeGlobal;
  var freeSelf = typeof self == "object" && self && self.Object === Object && self;
  var root = freeGlobal$1 || freeSelf || Function("return this")();
  const root$1 = root;
  var Symbol$1 = root$1.Symbol;
  const Symbol$2 = Symbol$1;
  var objectProto$b = Object.prototype;
  var hasOwnProperty$8 = objectProto$b.hasOwnProperty;
  var nativeObjectToString$1 = objectProto$b.toString;
  var symToStringTag$1 = Symbol$2 ? Symbol$2.toStringTag : void 0;
  function getRawTag(value) {
    var isOwn = hasOwnProperty$8.call(value, symToStringTag$1), tag = value[symToStringTag$1];
    try {
      value[symToStringTag$1] = void 0;
      var unmasked = true;
    } catch (e) {
    }
    var result = nativeObjectToString$1.call(value);
    if (unmasked) {
      if (isOwn) {
        value[symToStringTag$1] = tag;
      } else {
        delete value[symToStringTag$1];
      }
    }
    return result;
  }
  var objectProto$a = Object.prototype;
  var nativeObjectToString = objectProto$a.toString;
  function objectToString(value) {
    return nativeObjectToString.call(value);
  }
  var nullTag = "[object Null]", undefinedTag = "[object Undefined]";
  var symToStringTag = Symbol$2 ? Symbol$2.toStringTag : void 0;
  function baseGetTag(value) {
    if (value == null) {
      return value === void 0 ? undefinedTag : nullTag;
    }
    return symToStringTag && symToStringTag in Object(value) ? getRawTag(value) : objectToString(value);
  }
  function isObjectLike(value) {
    return value != null && typeof value == "object";
  }
  var isArray = Array.isArray;
  const isArray$1 = isArray;
  function isObject(value) {
    var type = typeof value;
    return value != null && (type == "object" || type == "function");
  }
  var asyncTag = "[object AsyncFunction]", funcTag$1 = "[object Function]", genTag = "[object GeneratorFunction]", proxyTag = "[object Proxy]";
  function isFunction(value) {
    if (!isObject(value)) {
      return false;
    }
    var tag = baseGetTag(value);
    return tag == funcTag$1 || tag == genTag || tag == asyncTag || tag == proxyTag;
  }
  var coreJsData = root$1["__core-js_shared__"];
  const coreJsData$1 = coreJsData;
  var maskSrcKey = function() {
    var uid = /[^.]+$/.exec(coreJsData$1 && coreJsData$1.keys && coreJsData$1.keys.IE_PROTO || "");
    return uid ? "Symbol(src)_1." + uid : "";
  }();
  function isMasked(func) {
    return !!maskSrcKey && maskSrcKey in func;
  }
  var funcProto$1 = Function.prototype;
  var funcToString$1 = funcProto$1.toString;
  function toSource(func) {
    if (func != null) {
      try {
        return funcToString$1.call(func);
      } catch (e) {
      }
      try {
        return func + "";
      } catch (e) {
      }
    }
    return "";
  }
  var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;
  var reIsHostCtor = /^\[object .+?Constructor\]$/;
  var funcProto = Function.prototype, objectProto$9 = Object.prototype;
  var funcToString = funcProto.toString;
  var hasOwnProperty$7 = objectProto$9.hasOwnProperty;
  var reIsNative = RegExp(
    "^" + funcToString.call(hasOwnProperty$7).replace(reRegExpChar, "\\$&").replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, "$1.*?") + "$"
  );
  function baseIsNative(value) {
    if (!isObject(value) || isMasked(value)) {
      return false;
    }
    var pattern2 = isFunction(value) ? reIsNative : reIsHostCtor;
    return pattern2.test(toSource(value));
  }
  function getValue(object, key) {
    return object == null ? void 0 : object[key];
  }
  function getNative(object, key) {
    var value = getValue(object, key);
    return baseIsNative(value) ? value : void 0;
  }
  var WeakMap = getNative(root$1, "WeakMap");
  const WeakMap$1 = WeakMap;
  var MAX_SAFE_INTEGER$1 = 9007199254740991;
  var reIsUint = /^(?:0|[1-9]\d*)$/;
  function isIndex(value, length) {
    var type = typeof value;
    length = length == null ? MAX_SAFE_INTEGER$1 : length;
    return !!length && (type == "number" || type != "symbol" && reIsUint.test(value)) && (value > -1 && value % 1 == 0 && value < length);
  }
  function eq(value, other) {
    return value === other || value !== value && other !== other;
  }
  var MAX_SAFE_INTEGER = 9007199254740991;
  function isLength(value) {
    return typeof value == "number" && value > -1 && value % 1 == 0 && value <= MAX_SAFE_INTEGER;
  }
  function isArrayLike(value) {
    return value != null && isLength(value.length) && !isFunction(value);
  }
  var objectProto$8 = Object.prototype;
  function isPrototype(value) {
    var Ctor = value && value.constructor, proto = typeof Ctor == "function" && Ctor.prototype || objectProto$8;
    return value === proto;
  }
  function baseTimes(n, iteratee) {
    var index = -1, result = Array(n);
    while (++index < n) {
      result[index] = iteratee(index);
    }
    return result;
  }
  var argsTag$2 = "[object Arguments]";
  function baseIsArguments(value) {
    return isObjectLike(value) && baseGetTag(value) == argsTag$2;
  }
  var objectProto$7 = Object.prototype;
  var hasOwnProperty$6 = objectProto$7.hasOwnProperty;
  var propertyIsEnumerable$1 = objectProto$7.propertyIsEnumerable;
  var isArguments = baseIsArguments(function() {
    return arguments;
  }()) ? baseIsArguments : function(value) {
    return isObjectLike(value) && hasOwnProperty$6.call(value, "callee") && !propertyIsEnumerable$1.call(value, "callee");
  };
  const isArguments$1 = isArguments;
  function stubFalse() {
    return false;
  }
  var freeExports$1 = typeof exports2 == "object" && exports2 && !exports2.nodeType && exports2;
  var freeModule$1 = freeExports$1 && typeof module == "object" && module && !module.nodeType && module;
  var moduleExports$1 = freeModule$1 && freeModule$1.exports === freeExports$1;
  var Buffer = moduleExports$1 ? root$1.Buffer : void 0;
  var nativeIsBuffer = Buffer ? Buffer.isBuffer : void 0;
  var isBuffer = nativeIsBuffer || stubFalse;
  const isBuffer$1 = isBuffer;
  var argsTag$1 = "[object Arguments]", arrayTag$1 = "[object Array]", boolTag$1 = "[object Boolean]", dateTag$1 = "[object Date]", errorTag$1 = "[object Error]", funcTag = "[object Function]", mapTag$2 = "[object Map]", numberTag$1 = "[object Number]", objectTag$2 = "[object Object]", regexpTag$1 = "[object RegExp]", setTag$2 = "[object Set]", stringTag$1 = "[object String]", weakMapTag$1 = "[object WeakMap]";
  var arrayBufferTag$1 = "[object ArrayBuffer]", dataViewTag$2 = "[object DataView]", float32Tag = "[object Float32Array]", float64Tag = "[object Float64Array]", int8Tag = "[object Int8Array]", int16Tag = "[object Int16Array]", int32Tag = "[object Int32Array]", uint8Tag = "[object Uint8Array]", uint8ClampedTag = "[object Uint8ClampedArray]", uint16Tag = "[object Uint16Array]", uint32Tag = "[object Uint32Array]";
  var typedArrayTags = {};
  typedArrayTags[float32Tag] = typedArrayTags[float64Tag] = typedArrayTags[int8Tag] = typedArrayTags[int16Tag] = typedArrayTags[int32Tag] = typedArrayTags[uint8Tag] = typedArrayTags[uint8ClampedTag] = typedArrayTags[uint16Tag] = typedArrayTags[uint32Tag] = true;
  typedArrayTags[argsTag$1] = typedArrayTags[arrayTag$1] = typedArrayTags[arrayBufferTag$1] = typedArrayTags[boolTag$1] = typedArrayTags[dataViewTag$2] = typedArrayTags[dateTag$1] = typedArrayTags[errorTag$1] = typedArrayTags[funcTag] = typedArrayTags[mapTag$2] = typedArrayTags[numberTag$1] = typedArrayTags[objectTag$2] = typedArrayTags[regexpTag$1] = typedArrayTags[setTag$2] = typedArrayTags[stringTag$1] = typedArrayTags[weakMapTag$1] = false;
  function baseIsTypedArray(value) {
    return isObjectLike(value) && isLength(value.length) && !!typedArrayTags[baseGetTag(value)];
  }
  function baseUnary(func) {
    return function(value) {
      return func(value);
    };
  }
  var freeExports = typeof exports2 == "object" && exports2 && !exports2.nodeType && exports2;
  var freeModule = freeExports && typeof module == "object" && module && !module.nodeType && module;
  var moduleExports = freeModule && freeModule.exports === freeExports;
  var freeProcess = moduleExports && freeGlobal$1.process;
  var nodeUtil = function() {
    try {
      var types = freeModule && freeModule.require && freeModule.require("util").types;
      if (types) {
        return types;
      }
      return freeProcess && freeProcess.binding && freeProcess.binding("util");
    } catch (e) {
    }
  }();
  const nodeUtil$1 = nodeUtil;
  var nodeIsTypedArray = nodeUtil$1 && nodeUtil$1.isTypedArray;
  var isTypedArray = nodeIsTypedArray ? baseUnary(nodeIsTypedArray) : baseIsTypedArray;
  const isTypedArray$1 = isTypedArray;
  var objectProto$6 = Object.prototype;
  var hasOwnProperty$5 = objectProto$6.hasOwnProperty;
  function arrayLikeKeys(value, inherited) {
    var isArr = isArray$1(value), isArg = !isArr && isArguments$1(value), isBuff = !isArr && !isArg && isBuffer$1(value), isType = !isArr && !isArg && !isBuff && isTypedArray$1(value), skipIndexes = isArr || isArg || isBuff || isType, result = skipIndexes ? baseTimes(value.length, String) : [], length = result.length;
    for (var key in value) {
      if ((inherited || hasOwnProperty$5.call(value, key)) && !(skipIndexes && (key == "length" || isBuff && (key == "offset" || key == "parent") || isType && (key == "buffer" || key == "byteLength" || key == "byteOffset") || isIndex(key, length)))) {
        result.push(key);
      }
    }
    return result;
  }
  function overArg(func, transform) {
    return function(arg) {
      return func(transform(arg));
    };
  }
  var nativeKeys = overArg(Object.keys, Object);
  const nativeKeys$1 = nativeKeys;
  var objectProto$5 = Object.prototype;
  var hasOwnProperty$4 = objectProto$5.hasOwnProperty;
  function baseKeys(object) {
    if (!isPrototype(object)) {
      return nativeKeys$1(object);
    }
    var result = [];
    for (var key in Object(object)) {
      if (hasOwnProperty$4.call(object, key) && key != "constructor") {
        result.push(key);
      }
    }
    return result;
  }
  function keys(object) {
    return isArrayLike(object) ? arrayLikeKeys(object) : baseKeys(object);
  }
  var nativeCreate = getNative(Object, "create");
  const nativeCreate$1 = nativeCreate;
  function hashClear() {
    this.__data__ = nativeCreate$1 ? nativeCreate$1(null) : {};
    this.size = 0;
  }
  function hashDelete(key) {
    var result = this.has(key) && delete this.__data__[key];
    this.size -= result ? 1 : 0;
    return result;
  }
  var HASH_UNDEFINED$2 = "__lodash_hash_undefined__";
  var objectProto$4 = Object.prototype;
  var hasOwnProperty$3 = objectProto$4.hasOwnProperty;
  function hashGet(key) {
    var data = this.__data__;
    if (nativeCreate$1) {
      var result = data[key];
      return result === HASH_UNDEFINED$2 ? void 0 : result;
    }
    return hasOwnProperty$3.call(data, key) ? data[key] : void 0;
  }
  var objectProto$3 = Object.prototype;
  var hasOwnProperty$2 = objectProto$3.hasOwnProperty;
  function hashHas(key) {
    var data = this.__data__;
    return nativeCreate$1 ? data[key] !== void 0 : hasOwnProperty$2.call(data, key);
  }
  var HASH_UNDEFINED$1 = "__lodash_hash_undefined__";
  function hashSet(key, value) {
    var data = this.__data__;
    this.size += this.has(key) ? 0 : 1;
    data[key] = nativeCreate$1 && value === void 0 ? HASH_UNDEFINED$1 : value;
    return this;
  }
  function Hash(entries) {
    var index = -1, length = entries == null ? 0 : entries.length;
    this.clear();
    while (++index < length) {
      var entry = entries[index];
      this.set(entry[0], entry[1]);
    }
  }
  Hash.prototype.clear = hashClear;
  Hash.prototype["delete"] = hashDelete;
  Hash.prototype.get = hashGet;
  Hash.prototype.has = hashHas;
  Hash.prototype.set = hashSet;
  function listCacheClear() {
    this.__data__ = [];
    this.size = 0;
  }
  function assocIndexOf(array, key) {
    var length = array.length;
    while (length--) {
      if (eq(array[length][0], key)) {
        return length;
      }
    }
    return -1;
  }
  var arrayProto = Array.prototype;
  var splice = arrayProto.splice;
  function listCacheDelete(key) {
    var data = this.__data__, index = assocIndexOf(data, key);
    if (index < 0) {
      return false;
    }
    var lastIndex = data.length - 1;
    if (index == lastIndex) {
      data.pop();
    } else {
      splice.call(data, index, 1);
    }
    --this.size;
    return true;
  }
  function listCacheGet(key) {
    var data = this.__data__, index = assocIndexOf(data, key);
    return index < 0 ? void 0 : data[index][1];
  }
  function listCacheHas(key) {
    return assocIndexOf(this.__data__, key) > -1;
  }
  function listCacheSet(key, value) {
    var data = this.__data__, index = assocIndexOf(data, key);
    if (index < 0) {
      ++this.size;
      data.push([key, value]);
    } else {
      data[index][1] = value;
    }
    return this;
  }
  function ListCache(entries) {
    var index = -1, length = entries == null ? 0 : entries.length;
    this.clear();
    while (++index < length) {
      var entry = entries[index];
      this.set(entry[0], entry[1]);
    }
  }
  ListCache.prototype.clear = listCacheClear;
  ListCache.prototype["delete"] = listCacheDelete;
  ListCache.prototype.get = listCacheGet;
  ListCache.prototype.has = listCacheHas;
  ListCache.prototype.set = listCacheSet;
  var Map = getNative(root$1, "Map");
  const Map$1 = Map;
  function mapCacheClear() {
    this.size = 0;
    this.__data__ = {
      "hash": new Hash(),
      "map": new (Map$1 || ListCache)(),
      "string": new Hash()
    };
  }
  function isKeyable(value) {
    var type = typeof value;
    return type == "string" || type == "number" || type == "symbol" || type == "boolean" ? value !== "__proto__" : value === null;
  }
  function getMapData(map, key) {
    var data = map.__data__;
    return isKeyable(key) ? data[typeof key == "string" ? "string" : "hash"] : data.map;
  }
  function mapCacheDelete(key) {
    var result = getMapData(this, key)["delete"](key);
    this.size -= result ? 1 : 0;
    return result;
  }
  function mapCacheGet(key) {
    return getMapData(this, key).get(key);
  }
  function mapCacheHas(key) {
    return getMapData(this, key).has(key);
  }
  function mapCacheSet(key, value) {
    var data = getMapData(this, key), size = data.size;
    data.set(key, value);
    this.size += data.size == size ? 0 : 1;
    return this;
  }
  function MapCache(entries) {
    var index = -1, length = entries == null ? 0 : entries.length;
    this.clear();
    while (++index < length) {
      var entry = entries[index];
      this.set(entry[0], entry[1]);
    }
  }
  MapCache.prototype.clear = mapCacheClear;
  MapCache.prototype["delete"] = mapCacheDelete;
  MapCache.prototype.get = mapCacheGet;
  MapCache.prototype.has = mapCacheHas;
  MapCache.prototype.set = mapCacheSet;
  function arrayPush(array, values) {
    var index = -1, length = values.length, offset = array.length;
    while (++index < length) {
      array[offset + index] = values[index];
    }
    return array;
  }
  function stackClear() {
    this.__data__ = new ListCache();
    this.size = 0;
  }
  function stackDelete(key) {
    var data = this.__data__, result = data["delete"](key);
    this.size = data.size;
    return result;
  }
  function stackGet(key) {
    return this.__data__.get(key);
  }
  function stackHas(key) {
    return this.__data__.has(key);
  }
  var LARGE_ARRAY_SIZE = 200;
  function stackSet(key, value) {
    var data = this.__data__;
    if (data instanceof ListCache) {
      var pairs = data.__data__;
      if (!Map$1 || pairs.length < LARGE_ARRAY_SIZE - 1) {
        pairs.push([key, value]);
        this.size = ++data.size;
        return this;
      }
      data = this.__data__ = new MapCache(pairs);
    }
    data.set(key, value);
    this.size = data.size;
    return this;
  }
  function Stack(entries) {
    var data = this.__data__ = new ListCache(entries);
    this.size = data.size;
  }
  Stack.prototype.clear = stackClear;
  Stack.prototype["delete"] = stackDelete;
  Stack.prototype.get = stackGet;
  Stack.prototype.has = stackHas;
  Stack.prototype.set = stackSet;
  function arrayFilter(array, predicate) {
    var index = -1, length = array == null ? 0 : array.length, resIndex = 0, result = [];
    while (++index < length) {
      var value = array[index];
      if (predicate(value, index, array)) {
        result[resIndex++] = value;
      }
    }
    return result;
  }
  function stubArray() {
    return [];
  }
  var objectProto$2 = Object.prototype;
  var propertyIsEnumerable = objectProto$2.propertyIsEnumerable;
  var nativeGetSymbols = Object.getOwnPropertySymbols;
  var getSymbols = !nativeGetSymbols ? stubArray : function(object) {
    if (object == null) {
      return [];
    }
    object = Object(object);
    return arrayFilter(nativeGetSymbols(object), function(symbol) {
      return propertyIsEnumerable.call(object, symbol);
    });
  };
  const getSymbols$1 = getSymbols;
  function baseGetAllKeys(object, keysFunc, symbolsFunc) {
    var result = keysFunc(object);
    return isArray$1(object) ? result : arrayPush(result, symbolsFunc(object));
  }
  function getAllKeys(object) {
    return baseGetAllKeys(object, keys, getSymbols$1);
  }
  var DataView = getNative(root$1, "DataView");
  const DataView$1 = DataView;
  var Promise$1 = getNative(root$1, "Promise");
  const Promise$2 = Promise$1;
  var Set = getNative(root$1, "Set");
  const Set$1 = Set;
  var mapTag$1 = "[object Map]", objectTag$1 = "[object Object]", promiseTag = "[object Promise]", setTag$1 = "[object Set]", weakMapTag = "[object WeakMap]";
  var dataViewTag$1 = "[object DataView]";
  var dataViewCtorString = toSource(DataView$1), mapCtorString = toSource(Map$1), promiseCtorString = toSource(Promise$2), setCtorString = toSource(Set$1), weakMapCtorString = toSource(WeakMap$1);
  var getTag = baseGetTag;
  if (DataView$1 && getTag(new DataView$1(new ArrayBuffer(1))) != dataViewTag$1 || Map$1 && getTag(new Map$1()) != mapTag$1 || Promise$2 && getTag(Promise$2.resolve()) != promiseTag || Set$1 && getTag(new Set$1()) != setTag$1 || WeakMap$1 && getTag(new WeakMap$1()) != weakMapTag) {
    getTag = function(value) {
      var result = baseGetTag(value), Ctor = result == objectTag$1 ? value.constructor : void 0, ctorString = Ctor ? toSource(Ctor) : "";
      if (ctorString) {
        switch (ctorString) {
          case dataViewCtorString:
            return dataViewTag$1;
          case mapCtorString:
            return mapTag$1;
          case promiseCtorString:
            return promiseTag;
          case setCtorString:
            return setTag$1;
          case weakMapCtorString:
            return weakMapTag;
        }
      }
      return result;
    };
  }
  const getTag$1 = getTag;
  var Uint8Array = root$1.Uint8Array;
  const Uint8Array$1 = Uint8Array;
  var HASH_UNDEFINED = "__lodash_hash_undefined__";
  function setCacheAdd(value) {
    this.__data__.set(value, HASH_UNDEFINED);
    return this;
  }
  function setCacheHas(value) {
    return this.__data__.has(value);
  }
  function SetCache(values) {
    var index = -1, length = values == null ? 0 : values.length;
    this.__data__ = new MapCache();
    while (++index < length) {
      this.add(values[index]);
    }
  }
  SetCache.prototype.add = SetCache.prototype.push = setCacheAdd;
  SetCache.prototype.has = setCacheHas;
  function arraySome(array, predicate) {
    var index = -1, length = array == null ? 0 : array.length;
    while (++index < length) {
      if (predicate(array[index], index, array)) {
        return true;
      }
    }
    return false;
  }
  function cacheHas(cache, key) {
    return cache.has(key);
  }
  var COMPARE_PARTIAL_FLAG$3 = 1, COMPARE_UNORDERED_FLAG$1 = 2;
  function equalArrays(array, other, bitmask, customizer, equalFunc, stack) {
    var isPartial = bitmask & COMPARE_PARTIAL_FLAG$3, arrLength = array.length, othLength = other.length;
    if (arrLength != othLength && !(isPartial && othLength > arrLength)) {
      return false;
    }
    var arrStacked = stack.get(array);
    var othStacked = stack.get(other);
    if (arrStacked && othStacked) {
      return arrStacked == other && othStacked == array;
    }
    var index = -1, result = true, seen = bitmask & COMPARE_UNORDERED_FLAG$1 ? new SetCache() : void 0;
    stack.set(array, other);
    stack.set(other, array);
    while (++index < arrLength) {
      var arrValue = array[index], othValue = other[index];
      if (customizer) {
        var compared = isPartial ? customizer(othValue, arrValue, index, other, array, stack) : customizer(arrValue, othValue, index, array, other, stack);
      }
      if (compared !== void 0) {
        if (compared) {
          continue;
        }
        result = false;
        break;
      }
      if (seen) {
        if (!arraySome(other, function(othValue2, othIndex) {
          if (!cacheHas(seen, othIndex) && (arrValue === othValue2 || equalFunc(arrValue, othValue2, bitmask, customizer, stack))) {
            return seen.push(othIndex);
          }
        })) {
          result = false;
          break;
        }
      } else if (!(arrValue === othValue || equalFunc(arrValue, othValue, bitmask, customizer, stack))) {
        result = false;
        break;
      }
    }
    stack["delete"](array);
    stack["delete"](other);
    return result;
  }
  function mapToArray(map) {
    var index = -1, result = Array(map.size);
    map.forEach(function(value, key) {
      result[++index] = [key, value];
    });
    return result;
  }
  function setToArray(set) {
    var index = -1, result = Array(set.size);
    set.forEach(function(value) {
      result[++index] = value;
    });
    return result;
  }
  var COMPARE_PARTIAL_FLAG$2 = 1, COMPARE_UNORDERED_FLAG = 2;
  var boolTag = "[object Boolean]", dateTag = "[object Date]", errorTag = "[object Error]", mapTag = "[object Map]", numberTag = "[object Number]", regexpTag = "[object RegExp]", setTag = "[object Set]", stringTag = "[object String]", symbolTag = "[object Symbol]";
  var arrayBufferTag = "[object ArrayBuffer]", dataViewTag = "[object DataView]";
  var symbolProto = Symbol$2 ? Symbol$2.prototype : void 0, symbolValueOf = symbolProto ? symbolProto.valueOf : void 0;
  function equalByTag(object, other, tag, bitmask, customizer, equalFunc, stack) {
    switch (tag) {
      case dataViewTag:
        if (object.byteLength != other.byteLength || object.byteOffset != other.byteOffset) {
          return false;
        }
        object = object.buffer;
        other = other.buffer;
      case arrayBufferTag:
        if (object.byteLength != other.byteLength || !equalFunc(new Uint8Array$1(object), new Uint8Array$1(other))) {
          return false;
        }
        return true;
      case boolTag:
      case dateTag:
      case numberTag:
        return eq(+object, +other);
      case errorTag:
        return object.name == other.name && object.message == other.message;
      case regexpTag:
      case stringTag:
        return object == other + "";
      case mapTag:
        var convert = mapToArray;
      case setTag:
        var isPartial = bitmask & COMPARE_PARTIAL_FLAG$2;
        convert || (convert = setToArray);
        if (object.size != other.size && !isPartial) {
          return false;
        }
        var stacked = stack.get(object);
        if (stacked) {
          return stacked == other;
        }
        bitmask |= COMPARE_UNORDERED_FLAG;
        stack.set(object, other);
        var result = equalArrays(convert(object), convert(other), bitmask, customizer, equalFunc, stack);
        stack["delete"](object);
        return result;
      case symbolTag:
        if (symbolValueOf) {
          return symbolValueOf.call(object) == symbolValueOf.call(other);
        }
    }
    return false;
  }
  var COMPARE_PARTIAL_FLAG$1 = 1;
  var objectProto$1 = Object.prototype;
  var hasOwnProperty$1 = objectProto$1.hasOwnProperty;
  function equalObjects(object, other, bitmask, customizer, equalFunc, stack) {
    var isPartial = bitmask & COMPARE_PARTIAL_FLAG$1, objProps = getAllKeys(object), objLength = objProps.length, othProps = getAllKeys(other), othLength = othProps.length;
    if (objLength != othLength && !isPartial) {
      return false;
    }
    var index = objLength;
    while (index--) {
      var key = objProps[index];
      if (!(isPartial ? key in other : hasOwnProperty$1.call(other, key))) {
        return false;
      }
    }
    var objStacked = stack.get(object);
    var othStacked = stack.get(other);
    if (objStacked && othStacked) {
      return objStacked == other && othStacked == object;
    }
    var result = true;
    stack.set(object, other);
    stack.set(other, object);
    var skipCtor = isPartial;
    while (++index < objLength) {
      key = objProps[index];
      var objValue = object[key], othValue = other[key];
      if (customizer) {
        var compared = isPartial ? customizer(othValue, objValue, key, other, object, stack) : customizer(objValue, othValue, key, object, other, stack);
      }
      if (!(compared === void 0 ? objValue === othValue || equalFunc(objValue, othValue, bitmask, customizer, stack) : compared)) {
        result = false;
        break;
      }
      skipCtor || (skipCtor = key == "constructor");
    }
    if (result && !skipCtor) {
      var objCtor = object.constructor, othCtor = other.constructor;
      if (objCtor != othCtor && ("constructor" in object && "constructor" in other) && !(typeof objCtor == "function" && objCtor instanceof objCtor && typeof othCtor == "function" && othCtor instanceof othCtor)) {
        result = false;
      }
    }
    stack["delete"](object);
    stack["delete"](other);
    return result;
  }
  var COMPARE_PARTIAL_FLAG = 1;
  var argsTag = "[object Arguments]", arrayTag = "[object Array]", objectTag = "[object Object]";
  var objectProto = Object.prototype;
  var hasOwnProperty = objectProto.hasOwnProperty;
  function baseIsEqualDeep(object, other, bitmask, customizer, equalFunc, stack) {
    var objIsArr = isArray$1(object), othIsArr = isArray$1(other), objTag = objIsArr ? arrayTag : getTag$1(object), othTag = othIsArr ? arrayTag : getTag$1(other);
    objTag = objTag == argsTag ? objectTag : objTag;
    othTag = othTag == argsTag ? objectTag : othTag;
    var objIsObj = objTag == objectTag, othIsObj = othTag == objectTag, isSameTag = objTag == othTag;
    if (isSameTag && isBuffer$1(object)) {
      if (!isBuffer$1(other)) {
        return false;
      }
      objIsArr = true;
      objIsObj = false;
    }
    if (isSameTag && !objIsObj) {
      stack || (stack = new Stack());
      return objIsArr || isTypedArray$1(object) ? equalArrays(object, other, bitmask, customizer, equalFunc, stack) : equalByTag(object, other, objTag, bitmask, customizer, equalFunc, stack);
    }
    if (!(bitmask & COMPARE_PARTIAL_FLAG)) {
      var objIsWrapped = objIsObj && hasOwnProperty.call(object, "__wrapped__"), othIsWrapped = othIsObj && hasOwnProperty.call(other, "__wrapped__");
      if (objIsWrapped || othIsWrapped) {
        var objUnwrapped = objIsWrapped ? object.value() : object, othUnwrapped = othIsWrapped ? other.value() : other;
        stack || (stack = new Stack());
        return equalFunc(objUnwrapped, othUnwrapped, bitmask, customizer, stack);
      }
    }
    if (!isSameTag) {
      return false;
    }
    stack || (stack = new Stack());
    return equalObjects(object, other, bitmask, customizer, equalFunc, stack);
  }
  function baseIsEqual(value, other, bitmask, customizer, stack) {
    if (value === other) {
      return true;
    }
    if (value == null || other == null || !isObjectLike(value) && !isObjectLike(other)) {
      return value !== value && other !== other;
    }
    return baseIsEqualDeep(value, other, bitmask, customizer, baseIsEqual, stack);
  }
  function isEqual(value, other) {
    return baseIsEqual(value, other);
  }
  const isCheckboxInput = (element) => element.type === "checkbox";
  const isNativeControl = (element) => {
    var _a;
    return ["input", "select", "textarea"].includes((_a = element.nodeName) == null ? void 0 : _a.toLowerCase());
  };
  const isRadioInput = (element) => element.type === "radio";
  const isMultipleSelect = (element) => element.type === `select-multiple`;
  const max = (max2, message = `This field must be less than ${max2}`) => (value) => {
    if (value && value > max2) {
      return message;
    }
    return true;
  };
  const maxLength = (max2, message = `This field must be less than ${max2} characters`) => (value) => {
    if (value && value.length > max2) {
      return message;
    }
    return true;
  };
  const min = (min2, message = `This field must be at least ${min2}`) => (value) => {
    if (value && value < min2) {
      return message;
    }
    return true;
  };
  const minLength = (min2, message = `This field must be at least ${min2} characters`) => (value) => {
    if (value && value.length < min2) {
      return message;
    }
    return true;
  };
  const pattern = (pattern2, message = "This field is invalid") => (value) => {
    if (value && !pattern2.test(value)) {
      return message;
    }
    return true;
  };
  const required = (message = "This field is required") => (value) => {
    if (value === void 0 || value === null || value === "") {
      return message;
    }
    return true;
  };
  const getNativeFieldValue = (el) => {
    var _a, _b;
    if (!el) {
      return DEFAULT_FIELD_VALUE;
    }
    if (Array.isArray(el)) {
      if (isRadioInput(el[0])) {
        return ((_a = el.find(({ checked, disabled }) => checked && !disabled)) == null ? void 0 : _a.value) || el[0].value;
      }
      return el[0].value;
    }
    if (isCheckboxInput(el)) {
      return el.checked;
    }
    if (isMultipleSelect(el)) {
      const values = (_b = [...el.options]) == null ? void 0 : _b.filter(({ selected }) => selected).map(({ value }) => value);
      return !values.length ? DEFAULT_FIELD_VALUE : values;
    }
    return el.value || DEFAULT_FIELD_VALUE;
  };
  const getDefaultFieldValue = (el) => {
    if (!el) {
      return DEFAULT_FIELD_VALUE;
    }
    if (isCheckboxInput(el)) {
      return false;
    }
    return DEFAULT_FIELD_VALUE;
  };
  const validateField = async ({
    name,
    values,
    formState,
    _refs
  }) => {
    var _a, _b;
    if (!Object.keys((_b = (_a = _refs[name]) == null ? void 0 : _a._validations) != null ? _b : {}).length) {
      return;
    }
    if (_refs[name]._disabled) {
      return;
    }
    for (const validation of Object.values(_refs[name]._validations)) {
      const result = await validation(values[name]);
      if (result !== true) {
        formState.errors[name] = result;
        break;
      }
      delete formState.errors[name];
    }
  };
  const validateForm = async (params) => {
    for (const name of Object.keys(params.values)) {
      await validateField({ ...params, name });
    }
  };
  const refFn = (name, _refs, values) => (fieldRef) => {
    if (!fieldRef) {
      delete _refs[name];
      return;
    }
    if (fieldRef.$el || !fieldRef.nodeName || !isNativeControl(fieldRef)) {
      _refs[name].ref = {
        type: "custom"
      };
      return;
    }
    const isFirstRegister = _refs[name] && (!_refs[name].ref || Array.isArray(_refs[name].ref) && isRadioInput(fieldRef) && !_refs[name].ref.some(
      (option) => option.value === fieldRef.value
    ));
    if (isFirstRegister) {
      _refs[name].ref = isRadioInput(fieldRef) ? [..._refs[name].ref || [], fieldRef] : fieldRef;
    }
    if (isRadioInput(fieldRef)) {
      if (isFirstRegister && !!fieldRef.checked) {
        values[name] = fieldRef.value;
        return;
      }
      fieldRef.checked = values[name] === fieldRef.value;
      return;
    }
    if (isCheckboxInput(fieldRef)) {
      if (isFirstRegister && !!fieldRef.checked) {
        values[name] = true;
        return;
      }
      fieldRef.checked = !!values[name];
      return;
    }
    if (isMultipleSelect(fieldRef)) {
      [...fieldRef.options].forEach((option, index) => {
        var _a;
        fieldRef[index].selected = !!((_a = values[name]) == null ? void 0 : _a.includes(option.value));
      });
      return;
    }
    fieldRef.value = values[name];
  };
  const transformValidations = (validations = {}) => {
    var _a;
    return {
      ...validations.required && {
        required: typeof validations.required === "string" ? required(validations.required) : required()
      },
      ...validations.min && {
        min: typeof validations.min === "number" ? min(validations.min) : min(validations.min.value, validations.min.message)
      },
      ...validations.max && {
        max: typeof validations.max === "number" ? max(validations.max) : max(validations.max.value, validations.max.message)
      },
      ...validations.minLength && {
        minLength: typeof validations.minLength === "number" ? minLength(validations.minLength) : minLength(
          validations.minLength.value,
          validations.minLength.message
        )
      },
      ...validations.maxLength && {
        maxLength: typeof validations.maxLength === "number" ? maxLength(validations.maxLength) : maxLength(
          validations.maxLength.value,
          validations.maxLength.message
        )
      },
      ...validations.pattern && {
        pattern: !((_a = validations.pattern) == null ? void 0 : _a.value) ? pattern(
          typeof validations.pattern === "string" ? new RegExp(validations.pattern) : validations.pattern
        ) : pattern(
          validations.pattern.value,
          validations.pattern.message
        )
      }
    };
  };
  const initialState = () => ({
    touched: {},
    dirty: {},
    errors: {},
    isDirty: false,
    isTouched: false,
    isValid: true
  });
  const useFormHandler = ({
    initialValues = {},
    interceptor,
    validate,
    validationMode = "onChange",
    injectionKey = defaultInjectionKey
  } = {}) => {
    const values = runtimeCore.reactive({ ...runtimeCore.unref(initialValues) });
    const formState = runtimeCore.reactive({ ...initialState() });
    let _refs = {};
    const _getDefault = (name) => {
      var _a, _b, _c;
      return (_c = (_a = _refs[name]) == null ? void 0 : _a._defaultValue) != null ? _c : getDefaultFieldValue((_b = _refs[name]) == null ? void 0 : _b.ref);
    };
    const _getInitial = (name) => {
      var _a, _b;
      return (_b = (_a = runtimeCore.unref(initialValues)) == null ? void 0 : _a[name]) != null ? _b : _getDefault(name);
    };
    const _initControl = (name, options) => {
      var _a;
      const needsReset = options.disabled && _refs[name] && !_refs[name]._disabled;
      _refs[name] = {
        ..._refs[name] || {},
        _validations: {
          ...!options.useNativeValidation && transformValidations(options),
          ...options.validate || {}
        },
        _defaultValue: options.defaultValue,
        _disabled: !!options.disabled
      };
      if (needsReset) {
        unregister(name);
        return;
      }
      if ((!initialValues || ((_a = runtimeCore.unref(initialValues)) == null ? void 0 : _a[name]) === void 0) && values[name] === void 0) {
        values[name] = _getDefault(name);
      }
    };
    const _updateValidState = () => {
      formState.isValid = !Object.values(formState.errors).some(Boolean);
    };
    const _updateDirtyState = () => {
      formState.isDirty = Object.values(formState.dirty).some(Boolean);
    };
    const _updateTouchedState = () => {
      formState.isTouched = Object.values(formState.touched).some(Boolean);
    };
    const clearError = (name) => {
      try {
        if (!name) {
          formState.errors = {};
          return;
        }
        delete formState.errors[name];
      } finally {
        _updateValidState();
      }
    };
    const triggerValidation = async (name) => {
      try {
        if (!name) {
          await validateForm({ formState, values, _refs });
          return;
        }
        await validateField({ formState, name, _refs, values });
      } finally {
        _updateValidState();
      }
    };
    const setDirty = (name, dirty) => {
      if (formState.dirty[name] !== dirty) {
        if (dirty) {
          formState.dirty[name] = true;
          formState.isDirty = true;
          return;
        }
        delete formState.dirty[name];
        _updateDirtyState();
      }
    };
    const setTouched = (name, touched) => {
      if (formState.touched[name] !== touched) {
        if (touched) {
          formState.touched[name] = true;
          formState.isTouched = true;
          return;
        }
        delete formState.touched[name];
        _updateTouchedState();
      }
    };
    const resetField = (name) => {
      values[name] = _getInitial(name);
      setTouched(name, false);
      setDirty(name, false);
      clearError(name);
    };
    const resetForm = () => {
      Object.assign(values, {
        ...Object.fromEntries(
          Object.keys(values).map((key) => [key, _getInitial(key)])
        )
      });
      Object.assign(formState, initialState());
    };
    const setError = (name, error) => {
      formState.errors[name] = error;
      _updateValidState();
    };
    const modifiedValues = () => {
      return Object.fromEntries(
        Object.entries(values).filter(([name]) => formState.dirty[name])
      );
    };
    const setValue = async (name, value = DEFAULT_FIELD_VALUE) => {
      var _a;
      if (!((_a = _refs[name]) == null ? void 0 : _a._disabled) && (!interceptor || await interceptor({
        clearError,
        clearField,
        formState,
        modifiedValues,
        name,
        resetField,
        resetForm,
        setError,
        setValue,
        triggerValidation,
        value,
        values
      }))) {
        values[name] = value;
        setDirty(name, !isEqual(value, _getInitial(name)));
        return;
      }
      if (isNativeControl(
        Array.isArray(_refs[name].ref) ? _refs[name].ref[0] : _refs[name].ref
      )) {
        const prev = values[name];
        values[name] = void 0;
        values[name] = prev;
      }
    };
    const handleBlur = (name) => {
      setTouched(name, true);
      if (["always", "onBlur"].includes(validationMode)) {
        triggerValidation(name);
      }
    };
    const handleChange = async (name, value = DEFAULT_FIELD_VALUE) => {
      await setValue(name, value);
      setTouched(name, true);
      if (["always", "onChange"].includes(validationMode)) {
        triggerValidation(name);
      }
    };
    const clearField = async (name) => {
      const defaultValue = _getDefault(name);
      if (defaultValue !== values[name]) {
        await setValue(name, defaultValue);
        await triggerValidation(name);
      }
    };
    const unregister = (name) => {
      delete _refs[name];
      delete values[name];
      delete formState.errors[name];
      delete formState.dirty[name];
      delete formState.touched[name];
      _updateTouchedState();
      _updateDirtyState();
      _updateValidState();
    };
    const register = (name, options = {}) => {
      const {
        validate: validate2,
        defaultValue,
        disabled,
        withDetails,
        native,
        useNativeValidation,
        pattern: pattern2,
        ...nativeValidations
      } = options;
      _initControl(name, options);
      return {
        name,
        modelValue: values[name],
        error: formState.errors[name],
        "onUpdate:modelValue": async (value) => await handleChange(name, value),
        ref: refFn(name, _refs, values),
        onBlur: () => handleBlur(name),
        onClear: () => clearField(name),
        ...disabled && { disabled: true },
        ...withDetails && {
          isDirty: !!formState.dirty[name],
          isTouched: !!formState.touched[name]
        },
        ...native !== false && {
          onChange: async () => {
            if (!_refs[name].ref || _refs[name].ref.type === "custom") {
              return;
            }
            await handleChange(name, getNativeFieldValue(_refs[name].ref));
          }
        },
        ...useNativeValidation && {
          ...{
            ...nativeValidations,
            ...pattern2 && {
              pattern: pattern2 instanceof RegExp ? pattern2.source : pattern2
            }
          }
        }
      };
    };
    const build = (configuration) => {
      const staticConfig = runtimeCore.unref(configuration);
      return runtimeCore.computed(
        () => Object.keys(staticConfig).reduce((acc, key) => {
          acc[key] = register(key, staticConfig[key]);
          return acc;
        }, {})
      );
    };
    const isValidForm = async () => {
      if (validate) {
        return await validate(values);
      }
      await triggerValidation();
      return formState.isValid;
    };
    const handleSubmit = async (successFn, errorFn) => {
      if (await isValidForm()) {
        successFn(values);
        return;
      }
      if (errorFn) {
        errorFn(formState.errors);
      }
    };
    runtimeCore.watch(
      () => initialValues,
      () => {
        resetForm();
      },
      { deep: true }
    );
    const toExpose = {
      clearError,
      clearField,
      formState: runtimeCore.readonly(formState),
      handleSubmit,
      modifiedValues,
      register,
      build,
      resetField,
      resetForm,
      setError,
      setValue,
      triggerValidation,
      unregister,
      values: runtimeCore.readonly(values)
    };
    runtimeCore.provide(injectionKey, toExpose);
    return toExpose;
  };
  const FormHandler = runtimeCore.defineComponent({
    name: "FormHandler",
    props: {
      initialValues: Object,
      interceptor: Function,
      validate: Function,
      validationMode: Object
    },
    setup: (props, { slots }) => {
      const { ...formHandler } = useFormHandler({
        initialValues: props.initialValues,
        interceptor: props.interceptor,
        validate: props.validate,
        validationMode: props.validationMode
      });
      return () => slots.default && slots.default({ ...formHandler });
    }
  });
  const useFormContext = (key = defaultInjectionKey) => runtimeCore.inject(key);
  exports2.BaseInputEmits = BaseInputEmits;
  exports2.BaseInputProps = BaseInputProps;
  exports2.DEFAULT_FIELD_VALUE = DEFAULT_FIELD_VALUE;
  exports2.FormHandler = FormHandler;
  exports2.defaultInjectionKey = defaultInjectionKey;
  exports2.initialState = initialState;
  exports2.useFormContext = useFormContext;
  exports2.useFormHandler = useFormHandler;
  Object.defineProperties(exports2, { __esModule: { value: true }, [Symbol.toStringTag]: { value: "Module" } });
});
//# sourceMappingURL=index.umd.cjs.map
